#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Jun  4 10:46:38 2023

@author: mac
"""

import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
import os

os.chdir('/Users/mac/Downloads/')
df = pd.read_excel('Bonds-analyse-ferdig.xlsm', sheet_name = 'Effects of inflation')
data = {
    'Category': ['Asset Duration', 'Liability Durations', 'Net Duration'],
    'TopPt1': [-11.471716720113, -0.771849330317, -10.699867389796],
    'RemainingTop1': [-11.129113900309, -1.297479597608, -9.831634302701],
    'Next9': [-9.489927572614, -1.428339004541, -8.061588568073],
    'Next40': [-9.140497106213, -1.231743919476, -7.908753186737],
    'Bottom50': [-10.269063170255, -0.839491456563, -9.429571713692]
}


durations = pd.DataFrame(data)
durations.index = durations.iloc[:,0]
durations = durations.iloc[:,1:]*-1


#%%

sns.set_theme(style = 'darkgrid')
sns.set_context('paper')
# Create the smoothed line plot
sns.lineplot(data=durations.iloc[2], x=durations.columns, y=durations.iloc[2], color = 'steelblue')
plt.savefig('net_dur.png')
plt.figure(figsize = (10,6),dpi = 300)
# Show the plot
plt.show()


#%%
import matplotlib.ticker as mtick
import seaborn as sns
import matplotlib.pyplot as plt

# Create the DataFrame
data = {
    'Category': ['Real estate', 'Equity Like', 'Bond Like'],
    'TopPt1': [0.08456486682929419, 0.9044746135805706, 0.010960519590135208],
    'NextPt9': [0.1694280573833739, 0.7819895644601076, 0.04858237815651851],
    'Next9': [0.2483035655605305, 0.48670851896729356, 0.264987915472176],
    'Next40': [0.40861814231350113, 0.2962298629913138, 0.295151994695185],
    'Bottom50': [0.7025449154755593, 0.19004539692517, 0.10740968759927068]
}

df = pd.DataFrame(data)


df.index = df.iloc[:,0]
df = df.iloc[:,1:]
df = df.transpose()
df = df.iloc[::-1]


sns.set_theme(style = 'darkgrid')
sns.set_context('paper')
df.plot(kind = 'bar', stacked = True, color = ['#7BAFD4', '#4682B4', '#1C567C'])
plt.legend(loc = 'lower left')
ax = plt.gca()
ax.yaxis.set_major_formatter(mtick.PercentFormatter(xmax=1))
plt.savefig('asset_wts.png')
plt.show()

#%%
data = {
    'Category': ['Home mortgages', 'Consumer credit & Other'],
    'TopPt1': [0.4483536213, 0.5516463787],
    'NextPt9': [0.7748320482, 0.2251679518],
    'Next9': [0.8561111829, 0.1438888171],
    'Next40': [0.7340024345, 0.2659975655],
    'Bottom50': [0.4903673643, 0.5096326357]
}

df = pd.DataFrame(data)
df.index = df.iloc[:,0]
df = df.iloc[:,1:]
df = df.transpose()
df = df.iloc[::-1]


sns.set_theme(style = 'darkgrid')
sns.set_context('paper')
df.plot(kind = 'bar', stacked = True, color = ['#7BAFD4', '#4682B4', '#1C567C'])
plt.legend(loc = 'lower left')
ax = plt.gca()
ax.yaxis.set_major_formatter(mtick.PercentFormatter(xmax=1))
plt.savefig('liab_wts.png')
plt.show()
#%% Slopes
d = pd.Series(range(0,51))
slopes = pd.DataFrame(index = d, columns = ['0.90', '0.53', '0.00'])
slopes['0.90'] = d*(1-0.9)
slopes['0.53'] = d*(1-.53)
slopes['0.00'] = d*(1-0)
sns.set_theme(style = 'darkgrid')
sns.set_context('paper')
slopes.plot(kind = 'line', stacked = True, color = ['#7BAFD4', '#4682B4', '#1C567C'])
plt.legend(loc = 'lower left')
ax = plt.gca()

plt.show()

#%%
import matplotlib.pyplot as plt
import pandas as pd
import seaborn as sns
import matplotlib.ticker as mtick
import colorsys

os.chdir('/Users/mac/Downloads/')

# Line plot data
durations_data = {
    'Category': ['Asset Duration', 'Liability Durations', 'Net Duration'],
    'TopPt1': [-11.781224133, -0.77184933, -11.009374802],
    'RemainingTop1': [-11.74922059, -1.297479598, -10.451740993],
    'Next9': [-10.398718623, -1.428339005, -8.970379618],
    'Next40': [-10.636039507, -1.231743919, -9.404295588],
    'Bottom50': [-12.840377561, -0.839491457, -12.000886104]
}

durations = pd.DataFrame(durations_data)
durations.index = durations.iloc[:,0]
durations = durations.iloc[:,1:]*-1
durations = durations.iloc[::-1]  # Reverse the order of rows

# Stacked bar plot data
asset_wts_data = {
    'Category': ['Real estate', 'Equity Like', 'Bond Like'],
    'TopPt1': [0.08456486682929419, 0.9044746135805706, 0.010960519590135208],
    'NextPt9': [0.1694280573833739, 0.7819895644601076, 0.04858237815651851],
    'Next9': [0.2483035655605305, 0.48670851896729356, 0.264987915472176],
    'Next40': [0.40861814231350113, 0.2962298629913138, 0.295151994695185],
    'Bottom50': [0.7025449154755593, 0.19004539692517, 0.10740968759927068]
}

df = pd.DataFrame(asset_wts_data)
df.index = df.iloc[:,0]
df = df.iloc[:,1:]
df = df.transpose()

# Darken the color
base_color = '#1C567C'
h, l, s = colorsys.rgb_to_hls(*(int(base_color[i:i+2], 16) / 255 for i in (1, 3, 5)))
darkened_color = '#' + ''.join(f'{int(c * 255):02x}' for c in colorsys.hls_to_rgb(h, max(l - 0.2, 0), s))

# Create the plot
fig, ax1 = plt.subplots(dpi=300, figsize=(6, 4))
sns.set_theme(style='darkgrid')
sns.set_context('paper', font_scale=0.7)

# Stacked bar plot
df.plot(kind='bar', stacked=True, color=['#7BAFD4', '#4682B4', base_color], ax=ax1, edgecolor='none')
ax1.legend(loc='lower left')
ax1.yaxis.set_major_formatter(mtick.PercentFormatter(xmax=1))
ax1.set_ylabel('Asset Weights')

# Secondary y-axis for line plot
ax2 = ax1.twinx()

# Line plot
sns.lineplot(data=durations.iloc[-1], x=durations.columns, y=durations.iloc[-1], color= '#164463', linewidth=1.5, ax=ax2)
ax2.set_ylabel('Duration')
ax2.grid(False)

# Adjust spacing between subplots
plt.subplots_adjust(right=0.8)

# Save the combined plot
plt.savefig('combined_plot_n.png')

# Show the plot
plt.show()
