#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun May 28 09:53:55 2023

@author: mac
"""
#Import libraries
import pandas as pd
import matplotlib.pyplot as plt
import os
from datetime import datetime as dt
import numpy as np
import statsmodels.api as sm
#Set Working Directory
os.chdir('/Users/mac/Downloads/')

#Import and clean datasets
df_shiller = pd.read_excel('ie_data.xls', sheet_name= 'Data').iloc[6:1832]
df_shiller.columns = df_shiller.iloc[0]
df_shiller = df_shiller.iloc[1:-1]
df_shiller['Date'] = df_shiller['Date'].astype(str).str.replace('.', '-')

reits = pd.read_excel('REIT index trial.xlsx', sheet_name = 'Data')
reits= reits[(reits['Date'] < '2023') & (reits['Date']> '1989')]
#%%
CPI = df_shiller['CPI'].iloc[::-1]
CPI = CPI.iloc[:len(reits)]
CPI = CPI.iloc[::-1].reset_index(inplace=False)
reits['CPI'] = CPI['CPI'].astype(float)

    
#%% Import and Clean CPI Data
less_shelter = pd.read_excel('CUUR0000SA0L2.xls').iloc[9:]
less_shelter.columns = less_shelter.iloc[0]
less_shelter = less_shelter.iloc[1:]
less_shelter['smoothed'] = np.nan
less_shelter.index = less_shelter.iloc[:,0]
for i in range(0,len(less_shelter)): #creating a smoothed cpi
    less_shelter['smoothed'].iloc[i] = np.average(less_shelter['CUUR0000SA0L2'].iloc[i-60:i])

less_shelter['pct'] = (less_shelter['smoothed']/less_shelter['smoothed'].shift(60))**(1/5)-1 #Annualized smoothed 5 year CPI growth

                                       
rent_CPI = pd.read_excel('CUUR0000SEHA (2).xls').iloc[9:]
rent_CPI.columns = rent_CPI.iloc[0]
rent_CPI = rent_CPI.iloc[1:]
rent_CPI['smoothed'] = np.nan
rent_CPI.index = rent_CPI.iloc[:,0]
for i in range(0,len(rent_CPI)):
    rent_CPI['smoothed'].iloc[i] = np.average(rent_CPI['CUUR0000SEHA'].iloc[i-60:i])

rent_CPI['pct'] = (rent_CPI['smoothed']/rent_CPI['smoothed'].shift(60))**(1/5)-1 #Annualized smoothed 5 year Rent growth

#%%
duration = 1/reits['Div Yield'].iloc[-1].astype(float) #1/[Implied Risk Premium]
df_shiller['Inflation'] = df_shiller['CPI']/df_shiller['CPI'].shift(12)-1
df_shiller['Real Rates'] = (1+df_shiller['Rate GS10']/100)/(1+df_shiller['Inflation'])-1

#%% Regression for inflation flow-through on rent
start = '1950'
end = '2023'
y = rent_CPI['pct'][(rent_CPI.index > start) & (rent_CPI.index < end)]
y = np.asarray(y)
X = less_shelter['pct'][(less_shelter.index > start) & (less_shelter.index < end)]
x = np.asarray(sm.add_constant(X.values))

model = sm.OLS(y,x).fit()
print(model.summary())

#%% #realigning Shiller data to work with regression
df_shiller = df_shiller.iloc[::-1].reset_index()
df_shiller = df_shiller.iloc[:len(reits)]
df_shiller = df_shiller.iloc[::-1]
#%%
# Convert 'Div Yield' to numeric type
y = np.asarray(reits['Div Yield'], dtype=float)

# Prepare 'x' with relevant columns from 'df_shiller'
x = df_shiller[['Real Rates', 'Inflation']]
x = np.asarray(sm.add_constant(x), dtype=float)

# Fit the OLS model
model = sm.OLS(y, x).fit()
print(model.summary())

#%%
i = 0.2842 #inflation effect on ERP, from regression
flow = 0.6556 #Flow-through, from  regression

inf_dur = duration * (1 - flow + i) #Formula for inflation duration
print(inf_dur)